package rocks.zipcode.quiz5.objectorientation.account;

/**
 * @author leon on 27/12/2018.
 */
public class BankAccount extends Account implements Transactable{
    private Double balance;

    public BankAccount(Double balance) {
        this.balance = balance;
    }

    public BankAccount() {
        balance = 0.0;
    }

    public void setBalance(Double val) {
        balance = val;
    }



    public void deposit(Double amountToIncreaseBy) {
        if(amountToIncreaseBy >= 0) {
            balance += amountToIncreaseBy;
        } else {
            throw new IllegalArgumentException();
        }
    }

    public void withdrawal(Double amountToDecreaseBy) {
        if(balance >= amountToDecreaseBy && amountToDecreaseBy > 0) {
            balance -= amountToDecreaseBy;
        } else {
            throw new IllegalArgumentException();
        }
    }

    public Double getBalance() {
        return balance;
    }


}
