package rocks.zipcode.quiz5.objectorientation.account;

/**
 * @author leon on 30/12/2018.
 */
public class Employee implements Transactable, Worker{
    private BankAccount bankAccount;
    private Double hrsWorked;
    private Double hrlyWage;

    public Employee() {
        this.hrsWorked = 0.0;
        this.hrlyWage = 35.0;
        this.bankAccount = new BankAccount();
    }

    public Employee(BankAccount bankAccount) {
        this();
        this.bankAccount = bankAccount;
    }

    public BankAccount getBankAccount() {
        return this.bankAccount;
    }

    public void setBankAccount(BankAccount bankAccount) {
        this.bankAccount = bankAccount;
    }

    @Override
    public void deposit(Double amountToIncreaseBy) {
        this.bankAccount.deposit(amountToIncreaseBy);

    }

    @Override
    public void withdrawal(Double amountToDecreaseBy) {
        this.bankAccount.withdrawal(amountToDecreaseBy);
    }

    @Override
    public Double getBalance() {
        return this.bankAccount.getBalance();
    }

    @Override
    public void increaseHoursWorked(Double numberOfHours) {
        this.hrsWorked += numberOfHours;
    }

    @Override
    public Double getHoursWorked() {
        return hrsWorked;
    }

    @Override
    public Double getHourlyWage() {
        return hrlyWage;
    }

    @Override
    public Double getMoneyEarned() {
        return hrlyWage * hrsWorked;
    }
}
